using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;

namespace GGC_ExcelTips
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            #region datatable
            DataTable dt = new DataTable("MyTable");

            int nCols = 4;
            int nRows = 20;
            Random r = new Random(123345345);

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));
            dt.Columns.Add(new DataColumn("ID", typeof(int)));


            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    dr[j] = r.Next(10);
                dr["ID"] = i;
                dt.Rows.Add(dr);
            }

            #endregion

            gridGroupingControl1.DataSource = dt;

            string primaryKeyId = "ID"; //primary key in the datatable...

            new TipHelper(gridGroupingControl1, primaryKeyId);

            //set a comment on some record
            Record rec = gridGroupingControl1.Table.UnsortedRecords[2];
            string fieldName = "Col2";
            TipHelper.SetCommentText("Some Comment", rec, fieldName);

            //set another comment
            rec = gridGroupingControl1.Table.UnsortedRecords[4];
            fieldName = "Col1";
            TipHelper.SetCommentText("Another Comment", rec, fieldName);

            TipHelper.AllowEdit(true);

        }
    }
}