using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC_ExcelTips
{
    class TipHelper
    {
        GridGroupingControl grid;
        static string primaryKeyColumn;
        static CommentMouseController controller;

        public TipHelper(GridGroupingControl grid, string primaryKeyColumn)
        {
            this.grid = grid;
            TipHelper.primaryKeyColumn = primaryKeyColumn;

            controller = new CommentMouseController(grid.TableControl);
            controller.ContextMenuEnabled = false;

            grid.TableControl.MouseControllerDispatcher.Add(controller);
        }

        public static void AllowEdit(bool allowEdit)
        {
            controller.ContextMenuEnabled = allowEdit;
        }
        public static void SetCommentText(string commentText, Record rec, string fieldName)
        {
            string key = GetLookUpValue(rec, fieldName);
            if (controller.CellTipStrings.ContainsKey(key))
            {
                controller.CellTipStrings[key] = commentText;
            }
            else
            {
                controller.CellTipStrings.Add(key, commentText);
            }
        }

        public static void ResetCommentText(Record rec, string fieldName)
        {
            string key = GetLookUpValue(rec, fieldName);
            if (controller.CellTipStrings.ContainsKey(key))
            {
                controller.CellTipStrings.Remove(key);
            }
        }

        public static string GetLookUpValue(Record rec, string fieldName)
        {
            return rec.GetValue(primaryKeyColumn).ToString() + "^" + fieldName;
        }
    }
}
